#ifndef __LCD_INIT_H
#define __LCD_INIT_H

#include "debug.h"

/////////////////////////////////////û/////////////////////////////////////
//ʾоƬͺ
#define ST7735S 0
#define ST7789 1

#define IMAGE_W 128//ͼƬ
#define IMAGE_H 160//ͼƬ߶
//#define IMAGE_NUM 73//ͼƬ

#define IMAGE_ADDR_STEP IMAGE_H * IMAGE_W * 2//spi flashÿͼƬĴСҲȡͼƬʱĵַ
#define IMAGE_BLOCK IMAGE_W * 2 * 10//ÿ10ͼƬĴС
//ֺ֧ٶл
#define USE_HORIZONTAL 0  //úʾ 01Ϊ 23Ϊ,Up
//#define USE_HORIZONTAL 1  //úʾ 01Ϊ 23Ϊ,Bottom
//#define USE_HORIZONTAL 2  //úʾ 01Ϊ 23Ϊ,Right
//#define USE_HORIZONTAL 3  //úʾ 01Ϊ 23Ϊ,Left

#if USE_HORIZONTAL == 0//Up
    #define DISPLAY_OVERTURN 0
    #define DISPLAY_BOTTOM_TO_TOP 0
    #define DISPLAY_RIGHT_TO_LEFT 0
#elif USE_HORIZONTAL == 1//Bottom
    #define DISPLAY_OVERTURN 0
    #define DISPLAY_BOTTOM_TO_TOP 1
    #define DISPLAY_RIGHT_TO_LEFT 1
#elif USE_HORIZONTAL == 2//Right
    #define DISPLAY_OVERTURN 1
    #define DISPLAY_BOTTOM_TO_TOP 0
    #define DISPLAY_RIGHT_TO_LEFT 1
#elif USE_HORIZONTAL == 3//Left
    #define DISPLAY_OVERTURN 1
    #define DISPLAY_BOTTOM_TO_TOP 1
    #define DISPLAY_RIGHT_TO_LEFT 0
#endif

//Ļߴ
#if USE_HORIZONTAL == 0 || USE_HORIZONTAL == 1
#define LCD_W 128//#define LCD_W 128
#define LCD_H 160//#define LCD_H 160 + 4
#else
#define LCD_W 160//#define LCD_W 160 + 4
#define LCD_H 128//#define LCD_H 128
#endif

//-----------------------------SPI --------------------------------------//
#define USE_HARDWARE_SPI    1   //1:Enable Hardware SPI;0:USE Soft SPI

//-------------------------Ļ--------------------------------------//
#define LCD_X_SIZE          128
#define LCD_Y_SIZE          160

#if USE_HORIZONTAL == 0 || USE_HORIZONTAL == 1
#define X_MAX_PIXEL         LCD_X_SIZE
#define Y_MAX_PIXEL         LCD_Y_SIZE
#else
#define X_MAX_PIXEL         LCD_Y_SIZE
#define Y_MAX_PIXEL         LCD_X_SIZE
#endif

////////////////////////////////////////////////////////////////////////////////////
#define LCD_CTRL        GPIOC      //TFTݶ˿
#define LCD_LED         GPIO_Pin_0  //PB9 TFT --LED
#define LCD_DC          GPIO_Pin_4 //PB10TFT --DC
#define LCD_CS          GPIO_Pin_1 //PB11TFT --CS
#define LCD_RESET       GPIO_Pin_3 //PB12TFT --RST
#define LCD_SCK         GPIO_Pin_1 //PB13TFT --CLK
#define LCD_SDI         GPIO_Pin_6 //PB15TFT --SDI(MOSI)

//Һƿ1궨
#define LCD_CS_SET     GPIO_SetBits(GPIOC,LCD_CS)// LCD_CTRL->BSHR=LCD_CS
#define LCD_DC_SET     GPIO_SetBits(GPIOC,LCD_DC)// LCD_CTRL->BSHR=LCD_DC
//#define LCD_SDI_SET     LCD_CTRL->BSHR=LCD_SDI
//#define LCD_SCK_SET     LCD_CTRL->BSHR=LCD_SCK
#define LCD_RESET_SET  GPIO_SetBits(GPIOC,LCD_RESET)// LCD_CTRL->BSHR=LCD_RESET
#define LCD_LED_SET    GPIO_SetBits(GPIOC,LCD_LED)// LCD_CTRL->BSHR=LCD_LED

//Һƿ0궨
#define LCD_CS_CLR     GPIO_ResetBits(GPIOC,LCD_CS)//CS LCD_CTRL->BCR=LCD_CS
#define LCD_DC_CLR     GPIO_ResetBits(GPIOC,LCD_DC)//DC LCD_CTRL->BCR=LCD_DC
//#define LCD_SDI_CLR     LCD_CTRL->BCR=LCD_SDI
//#define LCD_SCK_CLR     LCD_CTRL->BCR=LCD_SCK
#define LCD_RESET_CLR  GPIO_ResetBits(GPIOC,LCD_RESET)//RES LCD_CTRL->BCR=LCD_RESET
#define LCD_LED_CLR    GPIO_ResetBits(GPIOC,LCD_LED)//BLK LCD_CTRL->BCR=LCD_LED

//-----------------LCD˿ڶ---------------- 
//#define LCD_RES_Clr()  GPIO_ResetBits(GPIOB,GPIO_Pin_12)//RES
//#define LCD_RES_Set()  GPIO_SetBits(GPIOB,GPIO_Pin_12)
//
//#define LCD_DC_Clr()   GPIO_ResetBits(GPIOB,GPIO_Pin_10)//DC
//#define LCD_DC_Set()   GPIO_SetBits(GPIOB,GPIO_Pin_10)
//
//#define LCD_CS_Clr()   GPIO_ResetBits(GPIOB,GPIO_Pin_11)//CS
//#define LCD_CS_Set()   GPIO_SetBits(GPIOB,GPIO_Pin_11)
//
//#define LCD_BLK_Clr()  GPIO_ResetBits(GPIOB,GPIO_Pin_9)//BLK
//#define LCD_BLK_Set()  GPIO_SetBits(GPIOB,GPIO_Pin_9)



void LCD_GPIO_Init(void);//ʼGPIO
void LCD_WriteData(SPI_TypeDef* SPIx, u8 dat);//дһֽ
void LCD_WriteHalfWord(SPI_TypeDef* SPIx, u16 dat);//дֽ
void LCD_WriteData_Batch(SPI_TypeDef* SPIx, u8 *p, u16 num);
void LCD_WriteIndex(SPI_TypeDef* SPIx, u8 dat);//дһָ
void LCD_Address_Set(SPI_TypeDef* SPIx, u16 x1,u16 y1,u16 x2,u16 y2);//꺯
void LCD_Init(SPI_TypeDef* SPIx);//LCDʼ
#endif
