#ifndef __SPI_H
#define __SPI_H

#include "debug.h"
#include "lcd_init.h"
//#include "w25qxx.h"
//#include "dma.h"

////////////////////////////////////////////////////////////////////////////////////
#define BUF_SIZE  IMAGE_BLOCK

void SPI2_Init(void);
void SPI2_InitRx(void);
uint8_t SPI_ReadWriteByte(SPI_TypeDef* SPIx, uint8_t txdata);
uint8_t SPI_FLASH_SendByte(SPI_TypeDef* SPIx, uint8_t dat);
void SPI1_Flash_Init(void);
void SPI1_transmission(uint8_t *rx_buf, uint8_t *tx_buf, uint16_t NumByte);
void SPI_DMA_Read(SPI_TypeDef* SPIx, uint8_t *rx_buf, uint16_t NumByte);
void SPI_DMA_Write(SPI_TypeDef* SPIx, uint8_t *rx_data, uint8_t *tx_buf, uint16_t NumByte);
void SPI_LCD_WriteByte(SPI_TypeDef* SPIx, u8 Byte);
void SPI_LCD_WriteHalfWord(SPI_TypeDef* SPIx, u16 Data);
void SPI_LCD_Write_Batch(SPI_TypeDef* SPIx, u8 *p, u16 num);

#endif
