#include "spi.h"

u8 TxData[BUF_SIZE] = {0};
extern  uint8_t ID[4];

u8 Test_RX[BUF_SIZE] = {0x00};
//u8 Test_TX[1]={0xff};

/**
 * void SPI_Flash_Init(void)
 */
void SPI1_Flash_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};
    SPI_InitTypeDef  SPI_InitStructure = {0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC | RCC_APB2Periph_SPI1, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;//LED
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_SetBits(GPIOC, GPIO_Pin_0);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;//RESET
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
//    GPIO_SetBits(GPIOC, GPIO_Pin_3);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;//DC
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;//CS
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_SetBits(GPIOC, GPIO_Pin_1);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;//SCK
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;//MISO
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;//MOSI
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    SPI_InitStructure.SPI_Direction = SPI_Direction_1Line_Tx;
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI1, &SPI_InitStructure);
//    SPI1->HSCR |= 0x01;//ǿģʽ

    SPI_Cmd(SPI1, ENABLE);

//    DMA_Rx_Init(DMA1_Channel2, (u32)&SPI1->DATAR, (u32)Test_RX, BUF_SIZE );//RXFLASHȡ
//    DMA_Tx_Init(DMA1_Channel3, (u32)&SPI1->DATAR, (u32)TxData, 6);//TXFLASH0xff

    // SPI_I2S_DMACmd( SPI1, SPI_I2S_DMAReq_Tx, ENABLE );
    // SPI_I2S_DMACmd( SPI1, SPI_I2S_DMAReq_Rx, ENABLE );

}


/**
 * @brief 
 * дͬʱģֻҪҲҪд,ΪӻṩʱźţҸӻΪдЧݡ
 * @param SPIx 
 * @param txdata 
 * @return u8 
 */
u8 SPI_ReadWriteByte(SPI_TypeDef* SPIx, u8 txdata)
{
    u8 i = 0;

    while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == RESET)
    {
        i++;
        if(i > 200)
            return 0;//ʱ˳
    }
    SPI_I2S_SendData(SPIx, txdata);

//    i = 0;
//    while(SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET)
//    {
//        i++;
//        if(i > 200)
//            return 0;//ʱ˳
//    }
    return SPI_I2S_ReceiveData(SPIx);
}

/**
 * @brief SPI
 * 
 * @param rx_buf ͻ
 * @param tx_buf ջ
 * @param NumByte շĿ
 */
void SPI1_transmission(u8 *rx_buf, u8 *tx_buf, u16 NumByte)
{
    DMA1_Channel2->CNTR = NumByte;//趨ͨڴ
    DMA1_Channel3->CNTR = NumByte;

	
	DMA1_Channel2->CFGR |= (1 << 7);//򿪵ַ
	DMA1_Channel3->CFGR |= (1 << 7);
	
	DMA1_Channel2->MADDR = (u32)rx_buf;
	DMA1_Channel3->MADDR = (u32)tx_buf;
	
	SPI1->DATAR;//SPI DRĴ
	while((SPI1->STATR & (1 << 1)) == 0);//ȴ
	
	SPI1->CTLR2 |= SPI_I2S_DMAReq_Rx | SPI_I2S_DMAReq_Tx;
    DMA1_Channel2->CFGR |= DMA_CFGR1_EN;
    DMA1_Channel3->CFGR |= DMA_CFGR1_EN;

    while((DMA1->INTFR & DMA1_FLAG_TC2) == RESET);//ȴ
    while((DMA1->INTFR & DMA1_FLAG_TC3) == RESET);//ȴ

    DMA1_Channel2->CFGR &= ~DMA_CFGR1_EN;
    DMA1_Channel3->CFGR &= ~DMA_CFGR1_EN;
	SPI1->CTLR2 &= ~(uint16_t)(SPI_I2S_DMAReq_Rx | SPI_I2S_DMAReq_Tx);

    DMA1->INTFCR = DMA1_FLAG_TC2 | DMA1_FLAG_TC3;//ɱ־
}

/**
 * @brief SPI DMAȡ
 * 
 * @param rx_buf ջ
 * @param tx_data ͻ棬˺нȡκδ
 * @param NumByte ȡ
 */
void SPI_DMA_Read(SPI_TypeDef* SPIx, u8 *rx_buf, u16 NumByte)
{
    DMA1_Channel2->CNTR = NumByte;//趨DMAͨ2ݵ
    DMA1_Channel2->MADDR = (u32)rx_buf;//ָݵ

    SPI1->CTLR1 |= (1 << 10);//Ϊ˼ӿٶȣΪȡģʽ

    // SPI1->DATAR;//ջ
    // while((SPI1->STATR & (1 << 1)) == 0);//ͻ

    SPI1->CTLR2 |= SPI_I2S_DMAReq_Rx;
    DMA1_Channel2->CFGR |= DMA_CFGR1_EN;//DMA
    while((DMA1->INTFR & DMA1_FLAG_TC2) == RESET);//ȴ
    SPI1->CTLR2 &= ~(uint16_t)SPI_I2S_DMAReq_Rx;
    DMA1_Channel2->CFGR &= ~DMA_CFGR1_EN;//ɺرDMA
    DMA1->INTFCR = DMA1_FLAG_TC2;//ɱ־
    SPI1->CTLR1 &= ~(1 << 10);//ָ˫ģʽ
}

/**
 * @brief SPI DMAд
 * 
 * @param rx_data ջ棬˺нգ
 * @param tx_buf ͻ
 * @param NumByte 
 */
void SPI_DMA_Write(SPI_TypeDef* SPIx, u8 *rx_data, u8 *tx_buf, u16 NumByte)
{
    DMA1_Channel2->CNTR = NumByte;
    DMA1_Channel3->CNTR = NumByte;

    DMA1_Channel2->CFGR &= ~(1 << 7);

    DMA1_Channel2->MADDR = (u32)rx_data;
    DMA1_Channel3->MADDR = (u32)tx_buf;

    // SPI1->DATAR;//SPI
    // while((SPI1->STATR&(1 << 1)) == 0);

    SPI1->CTLR2 |= SPI_I2S_DMAReq_Rx | SPI_I2S_DMAReq_Tx;
    DMA1_Channel2->CFGR |= DMA_CFGR1_EN;
    DMA1_Channel3->CFGR |= DMA_CFGR1_EN;

    while((DMA1->INTFR & DMA1_FLAG_TC2) == RESET);//ȴ
    while((DMA1->INTFR & DMA1_FLAG_TC3) == RESET);//ȴ

    DMA1_Channel2->CFGR &= ~(uint16_t)DMA_CFGR1_EN;
    DMA1_Channel3->CFGR &= ~(uint16_t)DMA_CFGR1_EN;
    SPI1->CTLR2 &= ~(uint16_t)(SPI_I2S_DMAReq_Rx | SPI_I2S_DMAReq_Tx);

    DMA1->INTFCR = DMA1_FLAG_TC2 | DMA1_FLAG_TC3;//ɱ־
}

/**
* @fn void SPI_LCD_WriteByte(SPI_TypeDef* SPIx,u8 Byte)
* @brief ӲSPIдһֽݵײ㺯
* @param SPIx SPI
* @param Byte 
* @return none
*/
void SPI_LCD_WriteByte(SPI_TypeDef* SPIx, u8 Byte)
{
    u8 temp;

    temp = Byte;//д

//    DMA1_Channel5->CNTR = 1;//дҪݳ
//    DMA1_Channel5->MADDR = (uint32_t)&temp;
//
//    // SPI2->DATAR;//SPI DRĴ
//    // while((SPI2->STATR & (1 << 1)) == 0);//ȴ
//
//    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, ENABLE); //ʹSPI͵DMA
//    DMA_Cmd(DMA1_Channel3, ENABLE);
//    while( DMA_GetFlagStatus(DMA1_FLAG_TC5) == RESET);//ȴ
//    DMA_Cmd(DMA1_Channel3, DISABLE);
//    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, DISABLE); //رSPI͵DMA
//    DMA_ClearFlag(DMA1_FLAG_TC3);//־
    SPI_ReadWriteByte(SPI1, temp);
}

/**
* @fn void SPI_WriteHalfWord(SPI_TypeDef* SPIx,u16 Data)
* @brief ӲSPIдֽݵײ㺯
* @param SPIx
* @param Byte
* @return none
*/
void SPI_LCD_WriteHalfWord(SPI_TypeDef* SPIx,u16 Data)
{
    u8 temp[2];
    temp[1] = Data & 0xff;//д
    temp[0] = (Data >> 8) & 0xff;//д

//    DMA1_Channel3->CNTR = 2;//дҪݳ
//    DMA1_Channel3->MADDR = (uint32_t)temp;
//
//    // SPI1->DATAR;//SPI DRĴ
//    // while((SPI1->STATR & (1 << 1)) == 0);//ȴ
//
//    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, ENABLE); //ʹSPI͵DMA
//    DMA_Cmd(DMA1_Channel3, ENABLE);
//    while( DMA_GetFlagStatus(DMA1_FLAG_TC3) == RESET);//ȴ
//    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, DISABLE); //رSPI͵DMA
//    DMA_Cmd(DMA1_Channel3, DISABLE);
//    DMA_ClearFlag(DMA1_FLAG_TC3);//־
    SPI_ReadWriteByte(SPI1, temp[0]);
    SPI_ReadWriteByte(SPI1, temp[1]);
}

/**
* @fn void SPI_WriteHalfWord(SPI_TypeDef* SPIx,u16 Data)
* @brief ӲSPIдһݵײ㺯
* @param SPIx
* @param Byte
* @return none
*/
void SPI_LCD_Write_Batch(SPI_TypeDef* SPIx, u8 *p, u16 num)
{
    DMA1_Channel3->CNTR = num;//дҪݳ
    DMA1_Channel3->MADDR = (uint32_t)p;

    // SPI1->DATAR;//SPI DRĴ
    // while((SPI1->STATR & (1 << 1)) == 0);//ȴ

    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, ENABLE); //ʹSPI͵DMA
    DMA_Cmd(DMA1_Channel3, ENABLE);
    while( DMA_GetFlagStatus(DMA1_FLAG_TC3) == RESET);//ȴ
    DMA_Cmd(DMA1_Channel3, DISABLE);
    SPI_I2S_DMACmd(SPI1, SPI_I2S_DMAReq_Tx, DISABLE); //رSPI͵DMA
    DMA_ClearFlag(DMA1_FLAG_TC3);//־
}
